<html>

<!--

#
# This file is part of MaePadWeb
# Copyright (c) 2010 Thomas Perl <thp.io/about>
# http://thp.io/2010/maepad/
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

-->

    <head>
        <title>MaePadWeb</title>
        <script type="text/javascript" src="/jquery.js"></script>
        <script type="text/javascript">

var selectedChecklistItem = null;
var selectedChecklistIndex = null;
var activeChecklistNodeId = null;

function switchTo(selector) {
    var items = Array("#nodelist", "#checklist", "#sketch", "#richtext");
    for (i=0; i<items.length; i++) {
        if (items[i] != selector) {
            $(items[i]).hide();
        }
    }
    $(selector).fadeIn();

    if (selector != "#nodelist") {
        $("#backlink").css('visibility', 'visible');
    } else {
        $("#backlink").css('visibility', 'hidden');
        $('#checklistToolbar').hide();
    }
}

var nodeTypes = new Array("UNKNOWN", "Text", "Sketch", "Checklist");
$(document).ready(function() {
    switchTo('#nodelist');
    $.getJSON('/nodelist.json', function(data) {
        var current = $('#nodelist_ul');
        current.html('');
        $.each(data, function() {
            current.append('<li><a onclick="setNodeTitle(\''+this[1]+'\');open'+nodeTypes[this[2]]+'('+this[0]+')"><span style="font-weight: bold;">'+this[1]+'</span><small style="color: #aaa;"><br>'+nodeTypes[this[2]]+'</small></a></li>');
        });
    });
});

function openText(nodeid) {
    switchTo('#richtext');
    $.get('/richtext.html?id='+nodeid, function(data) {
        $('#richtext').html(data);
    });
}

function openSketch(nodeid) {
    switchTo('#sketch');
    $('#sketch_img').attr('src', '/sketch.png?id='+nodeid);
}

function trueComesBack(data) {
    if (!data) {
        alert('A request to the web server failed.');
    }
}

function setNodeTitle(title) {
    $('#nodetitle').html(title);
}

function editChecklistItem(index, item) {
    if (selectedChecklistItem != null) {
        $(selectedChecklistItem).removeClass('selectedChecklistItem');
    }
    selectedChecklistItem = item;
    selectedChecklistIndex = index;
    if (index != null && item != null) {
        updateChecklistToolbar();
        $(item).addClass('selectedChecklistItem');
    }
}

function checklistAddNew() {
    var newItemText = prompt('Enter text for new item:', '');
    if (newItemText != null && newItemText != '') {
        $.getJSON('/checklist.addItem?id='+activeChecklistNodeId+'&text='+escape(newItemText), function(data) {
            if (data) {
                /* Reload checklist */
                openChecklist(activeChecklistNodeId);
            } else {
                alert('Could not save checklist item');
            }
        });
    }
}

function checklistDelete() {
    if (!confirm('Really delete this item?')) {
        return;
    }
    $.getJSON('/checklist.deleteItem?id='+selectedChecklistIndex, function(data) {
            if (data) {
                /* Reload checklist */
                openChecklist(activeChecklistNodeId);
            } else {
                alert('Could not save checklist item');
            }
    });
}

function checklistToggleBold() {
    var item = $(selectedChecklistItem);
    var span = item.find('span').first();
    var isBold = (span.css('font-weight') == 'bold');
    if (isBold) {
        span.css('font-weight', 'normal');
    } else {
        span.css('font-weight', 'bold');
    }
    $.getJSON('/checklist.setBold?id='+selectedChecklistIndex+'&bold='+(!isBold), trueComesBack);
    updateChecklistToolbar();
}

function checklistToggleStrike() {
    var item = $(selectedChecklistItem);
    var span = item.find('span').first();
    var isStrike = (span.css('text-decoration') == 'line-through');
    if (isStrike) {
        span.css('text-decoration', 'none');
    } else {
        span.css('text-decoration', 'line-through');
    }
    $.getJSON('/checklist.setStrike?id='+selectedChecklistIndex+'&strike='+(!isStrike), trueComesBack);
    updateChecklistToolbar();
}

function checklistToggleCheck() {
    var item = $(selectedChecklistItem);
    var checkbox = item.find('img').first();
    checkbox.toggleClass('checked');
    if (checkbox.hasClass('checked')) {
        checkbox.attr('src', '/icons/widgets_tickmark_list');
    } else {
        checkbox.attr('src', '/nix.gif');
    }
    $.getJSON('/checklist.setCheck?id='+selectedChecklistIndex+'&check='+checkbox.hasClass('checked'), trueComesBack);
    updateChecklistToolbar();
}

function checklistEditText() {
    var item = $(selectedChecklistItem);
    var span = item.find('span').first();
    newValue = prompt('Edit this node:', span.html());
    if (newValue == null) {
        /* ignore */
    } else if (newValue == '') {
        /* ask for delete */
        checklistDelete();
    } else {
        span.html(newValue);
        $.getJSON('/checklist.setText?id='+selectedChecklistIndex+'&text='+escape(newValue), trueComesBack);
    }
}

function updateChecklistToolbar()
{
    var item = $(selectedChecklistItem);
    var span = item.find('span').first();
    var checkbox = item.find('img').first();
    var isBold = (span.css('font-weight') == 'bold');
    var isStrike = (span.css('text-decoration') == 'line-through');
    var isChecked = checkbox.hasClass('checked');
    if (isBold) {
        $('#checklistToolbar #boldButton').addClass('selected');
    } else {
        $('#checklistToolbar #boldButton').removeClass('selected');
    }
    if (isStrike) {
        $('#checklistToolbar #strikeButton').addClass('selected');
    } else {
        $('#checklistToolbar #strikeButton').removeClass('selected');
    }
    if (isChecked) {
        $('#checklistToolbar #checkButton').addClass('selected');
    } else {
        $('#checklistToolbar #checkButton').removeClass('selected');
    }
}

function openChecklist(nodeid) {
    activeChecklistNodeId = nodeid;
    $('#checklistToolbar').fadeIn();

    switchTo('#checklist');
    $('#checklist_ul').html('');
    $.getJSON('/checklist.json?id='+nodeid, function(data) {
        var current = $('#checklist_ul');
        $.each(data, function() {
            var index = this[0];
            var name = this[1];
            var style = this[2];
            var color = this[3];
            var spanStyle = '';
            if (color != '000000') {
                spanStyle += 'color: #'+color+';';
            }
            if (style&(1<<2)) {
                spanStyle += 'text-decoration:line-through;';
            }
            if (style&(1<<1)) {
                spanStyle += 'font-weight:bold;';
            }
            current.append('<li><a ondblclick="checklistEditText();" onclick="editChecklistItem('+index+', this)"><img class="checklistBox '+((style&(1<<0))?"checked":"")+'" src="'+((style&(1<<0))?"/icons/widgets_tickmark_list":"/nix.gif")+'" onclick="editChecklistItem('+index+', $(this).parent());checklistToggleCheck();"><span style="'+spanStyle+'">'+name+'</span></a></li>');
        });
    });
}

        </script>
        <style type="text/css">
            body {
                margin: 0px;
                background-color: black;
                font-size: smaller;
                font-family: sans-serif;
            }
            h1 {
                position: fixed;
                top: 0px;
                left: 0px;
                right: 0px;
                color: white;
                font-size: 32px;
                vertical-align: middle;
                height: 56px;
                background-image: url(/theme/title_bg);
                padding: 0px;
                margin: 0px;
                border-bottom: 1px solid black;
            }
            a {
                cursor: default;
            }
            #nodelist ul, #checklist ul {
                list-style: none;
                padding: 0px;
                margin: 0px;
            }
            #nodelist li, #checklist li {
                background-color: #000;
                padding: 0px;
                color: white;
            }
            #nodelist li:nth-child(2n+1), #checklist li:nth-child(2n+1) {
                background-color: #080808;
            }
            #nodelist li a {
                display: block;
                padding: 15px;
                color: lightgrey;
                text-decoration: none;
                text-shadow: 0px 0px 3px black;
            }
            #checklist li a {
                display: block;
                padding: 10px;
                color: lightgrey;
                text-decoration: none;
                text-shadow: 0px 0px 3px black;
            }
            #checklist li a.selectedChecklistItem {
                background-image: url(/theme/toolbar_hi);
                background-color: #666; /* FIXME: take from theme */
            }
            #backlink a {
                color: white;
                font-weight: bold;
                text-decoration: none;
                display: block;
            }

            div#checklist {
                padding-bottom: 40px;
            }

            .checklistBox {
                vertical-align: middle;
                width: 20px;
                height: 20px;
                padding: 5px;
                margin: 5px;
            }

            #checklistToolbar img {
                width: 32px;
                height: 32px;
            }

            #checklistToolbar {
                position: fixed;
                left: 0px;
                right: 0px;
                bottom: 0px;
                height: 70px;
                background-image: url(/theme/toolbar_bg);
                background-color: black;
            }

            #checklistToolbar .selected {
                background-image: url(/theme/toolbar_hi);
                background-color: #666; /* FIXME: take from theme */
            }

            #checklistToolbar a {
                display: block;
                float: left;
                padding: 10px;
                color: white;
                font-weight: bold;
            }
        </style>
    </head>
    <body>
        <h1 id="x"><img src="/logo.png" style="vertical-align: middle; border-right: 1px solid black; padding: 14px;" alt="MaePadWeb"> <span style="font-weight: normal; padding: 4px; font-size: 20px;" id="nodetitle"></span>
        <span id="backlink" style="float: right;">
            <a onclick="setNodeTitle('');switchTo('#nodelist')"><img src="/theme/title_btn" alt="back" style="border-left: 1px solid black;"></a>
        </span>
        </h1><div style="padding-top: 56px; padding-bottom: 30px;">
        <div id="nodelist">
            <ul id="nodelist_ul"></ul>
        </div>
        <div id="checklist">
            <ul id="checklist_ul"></ul>
        </div>
        <div id="sketch">
            <img id="sketch_img" style="border: 1px solid black;">
        </div>
        <p id="richtext" style="border: 1px solid black; background-color: white;"></p>
        </div>
        <div id="checklistToolbar">
            <a id="checkButton" onclick="checklistToggleCheck();"><img src="/icons/widgets_tickmark_list" alt="CHECK" title=""></a>
            <a id="boldButton" onclick="checklistToggleBold();"><img src="/icons/general_bold" alt="BOLD" title=""></a>
            <a id="strikeButton" onclick="checklistToggleStrike();"><img src="/icons/strike" alt="STRIKE" title=""></a>
            <a id="colorButton" onclick="alert('Not yet implemented.');"><img src="/icons/palette" alt="COLOR" title=""></a>
            <a style="border-left: 1px solid white; margin: 10px; padding: 0px; height: 32px;"></a>
            <a id="addButton" onclick="checklistAddNew();"><img src="/icons/general_add" alt="ADD" title=""></a>
            <a id="editButton" onclick="checklistEditText();"><img src="/icons/sketch" alt="EDIT" title=""></a>
            <a id="deleteButton" onclick="checklistDelete();"><img src="/icons/general_delete" alt="DEL" title=""></a>
        </div>

        <!-- image preloading -->
        <img src="/theme/toolbar_hi" style="display: none;">
        <img src="/nix.gif" style="display: none;">

    </body>
</html>

